//
//  Board support package (PIC32MX250F128B)
//
#ifndef _BSP_CONFIG_H
#define _BSP_CONFIG_H

#include "peripheral/ports/plib_ports.h"

#define BSP_SWITCH_PORT     PORT_CHANNEL_B
#define BSP_LED_PORT        PORT_CHANNEL_B

typedef enum {
     BSP_SWITCH_1 = PORTS_BIT_POS_2,    // USART Rx
     BSP_SWITCH_2 = PORTS_BIT_POS_2,    // USART Rx
     BSP_SWITCH_3 = PORTS_BIT_POS_2,    // USART Rx
} BSP_SWITCH;

typedef enum {
    BSP_SWITCH_STATE_PRESSED  = 0,
    BSP_SWITCH_STATE_RELEASED = 1,
} BSP_SWITCH_STATE;

typedef enum {
    BSP_LED_1 = PORTS_BIT_POS_7,        // LED1
    BSP_LED_2 = PORTS_BIT_POS_8,        // LED2
    BSP_LED_3 = PORTS_BIT_POS_9,        // LED3
} BSP_LED;

typedef enum {
    BSP_LED_STATE_OFF = 1,
    BSP_LED_STATE_ON  = 0,
} BSP_LED_STATE;

void BSP_Initialize(void);
void BSP_LEDStateSet(BSP_LED led, BSP_LED_STATE state);
BSP_LED_STATE BSP_LEDStateGet(BSP_LED led);
void BSP_LEDToggle(BSP_LED led);
void BSP_LEDOn(BSP_LED led);
void BSP_LEDOff(BSP_LED led);
BSP_SWITCH_STATE BSP_SwitchStateGet(BSP_SWITCH bspSwitch);

#endif //_BSP_CONFIG_H

