//
//  Board support package (PIC32MX250F128B)
//
#include "peripheral/ports/plib_ports.h"
#include "bsp_config.h"

void BSP_Initialize(void) {
    return;
}

BSP_SWITCH_STATE BSP_SwitchStateGet(BSP_SWITCH bspSwitch) {
    return(PLIB_PORTS_PinGet(PORTS_ID_0, BSP_SWITCH_PORT, bspSwitch));
}

void BSP_LEDStateSet(BSP_LED led, BSP_LED_STATE state){
    PLIB_PORTS_PinWrite(PORTS_ID_0 , BSP_LED_PORT, led, state);
    return;
}

void BSP_LEDOn(BSP_LED led){
    PLIB_PORTS_PinWrite(PORTS_ID_0, BSP_LED_PORT, led, BSP_LED_STATE_ON);
    return;
}

void BSP_LEDOff(BSP_LED led){
    PLIB_PORTS_PinWrite(PORTS_ID_0, BSP_LED_PORT, led, BSP_LED_STATE_OFF);
    return;
}

BSP_LED_STATE BSP_LEDStateGet(BSP_LED led){
    return(PLIB_PORTS_PinGet(PORTS_ID_0, BSP_LED_PORT, led));
}

void BSP_LEDToggle(BSP_LED led){
    PLIB_PORTS_PinToggle(PORTS_ID_0, BSP_LED_PORT, led);
    return;
}
