//
//  I/O Port configuration (PIC32MX250F128B)
//
#include "peripheral/ports/plib_ports.h"
#include "peripheral/devcon/plib_devcon.h"

void SYS_PORTS_Initialize(void)
{
    /* AN and CN Pins Initialization */
//  PLIB_PORTS_AnPinsModeSelect  (PORTS_ID_0, SYS_PORT_AD1PCFG, PORTS_PIN_MODE_DIGITAL);
//  PLIB_PORTS_CnPinsPullUpEnable(PORTS_ID_0, SYS_PORT_CNPUE);
//  PLIB_PORTS_CnPinsEnable      (PORTS_ID_0, SYS_PORT_CNEN);
//  PLIB_PORTS_ChangeNoticeEnable(PORTS_ID_0);
    
    /* PORT B Initialization */
//  PLIB_PORTS_DirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, SYS_PORT_B_TRIS ^ 0xFFFF);
//  PLIB_PORTS_OpenDrainEnable   (PORTS_ID_0, PORT_CHANNEL_B, SYS_PORT_B_ODC);

    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_0,  PORTS_PIN_MODE_DIGITAL);   // AN0
    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_1,  PORTS_PIN_MODE_DIGITAL);   // AN1
    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_0,  PORTS_PIN_MODE_DIGITAL);   // AN2
    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_1,  PORTS_PIN_MODE_DIGITAL);   // AN3
    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_2,  PORTS_PIN_MODE_DIGITAL);   // AN4
    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_3,  PORTS_PIN_MODE_DIGITAL);   // AN5
    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_15, PORTS_PIN_MODE_DIGITAL);   // AN9
    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_14, PORTS_PIN_MODE_DIGITAL);   // AN10
    PLIB_PORTS_PinModePerPortSelect(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_13, PORTS_PIN_MODE_DIGITAL);   // AN11

    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_0);  //
    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_1);  //
//  PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_2);  // POSC
//  PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_3);  // POSC
    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_A, PORTS_BIT_POS_4);  //
//  PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_0);  // PGED1
//  PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_1);  // PGEC1
    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_2);  //
    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_3);  //
    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_4);  //
    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_5);  //
    PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_7);  // LED 1-
    PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_8);  // LED 2-
    PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_9);  // LED 3-
//  PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_10); // USB D+
//  PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_11); // USB D-
    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_13); //
//  PLIB_PORTS_PinDirectionOutputSet(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_14); // USB VBUSON
    PLIB_PORTS_PinDirectionInputSet (PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_15); //

    PLIB_PORTS_PinWrite(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_7, 1);            // LED turn off
    PLIB_PORTS_PinWrite(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_8, 1);            // LED turn off
    PLIB_PORTS_PinWrite(PORTS_ID_0, PORT_CHANNEL_B, PORTS_BIT_POS_9, 1);            // LED turn off

//  PLIB_DEVCON_SystemUnlock(DEVCON_ID_0);
//  PLIB_DEVCON_DeviceRegistersUnlock(DEVCON_ID_0, DEVCON_PPS_REGISTERS);
//  PLIB_PORTS_RemapInput (PORTS_ID_0, INPUT_FUNC_U1RX, INPUT_PIN_RPB2);
//  PLIB_PORTS_RemapOutput(PORTS_ID_0, OTPUT_FUNC_U1TX, OUTPUT_PIN_RPB3);
//  PLIB_DEVCON_DeviceRegistersLock(DEVCON_ID_0, DEVCON_PPS_REGISTERS);
//  PLIB_DEVCON_SystemLock(DEVCON_ID_0);

    return;
}
