//
//  Harmony system-wide define
//
#ifndef _SYSTEM_CONFIG_H_
#define _SYSTEM_CONFIG_H_

//#define _PLIB_UNSUPPORTED

#include <stdbool.h>

//
// System clock: sys_clk_static.c and system_init.c(#pragma)
//
#define SYS_CLK_FREQ                        40000000ul
#define SYS_CLK_BUS_PERIPHERAL_1            5000000ul
#define SYS_CLK_CONFIG_PRIMARY_XTAL         12000000ul
#define SYS_CLK_CONFIG_SECONDARY_XTAL       32768ul

#define SYS_INT                             true

//
//  System timer
//
#define SYS_TMR_POWER_STATE                 SYS_MODULE_POWER_RUN_FULL
#define SYS_TMR_DRIVER_INDEX                DRV_TMR_INDEX_0
#define SYS_TMR_MAX_CLIENT_OBJECTS          5
#define SYS_TMR_FREQUENCY                   1000
#define SYS_TMR_FREQUENCY_TOLERANCE         10
#define SYS_TMR_UNIT_RESOLUTION             10000
#define SYS_TMR_CLIENT_TOLERANCE            10
#define SYS_TMR_INTERRUPT_NOTIFICATION      false

//
//  Driver timer
//
#define DRV_TMR_INSTANCES_NUMBER            1
#define DRV_TMR_CLIENTS_NUMBER              1
#define DRV_TMR_INTERRUPT_MODE              true

#define DRV_TMR_PERIPHERAL_ID_IDX0          TMR_ID_2
#define DRV_TMR_INTERRUPT_SOURCE_IDX0       INT_SOURCE_TIMER_2
#define DRV_TMR_INTERRUPT_VECTOR_IDX0       INT_VECTOR_T2
#define DRV_TMR_ISR_VECTOR_IDX0             _TIMER_2_VECTOR             // See system_interrupt.c
#define DRV_TMR_INTERRUPT_PRIORITY_IDX0     INT_PRIORITY_LEVEL4
#define DRV_TMR_INTERRUPT_SUB_PRIORITY_IDX0 INT_SUBPRIORITY_LEVEL0
#define DRV_TMR_CLOCK_SOURCE_IDX0           DRV_TMR_CLKSOURCE_INTERNAL
#define DRV_TMR_PRESCALE_IDX0               TMR_PRESCALE_VALUE_256
#define DRV_TMR_OPERATION_MODE_IDX0         DRV_TMR_OPERATION_MODE_16_BIT
#define DRV_TMR_ASYNC_WRITE_ENABLE_IDX0     false
#define DRV_TMR_POWER_STATE_IDX0            SYS_MODULE_POWER_RUN_FULL

//
//  Driver USB
//
#define DRV_USB_DEVICE_SUPPORT              false
#define DRV_USB_HOST_SUPPORT                true
#define DRV_USB_INSTANCES_NUMBER            1
#define DRV_USB_INTERRUPT_MODE              true
#define DRV_USB_ENDPOINTS_NUMBER            1
#define DRV_USB_HOST_PIPES_NUMBER           6
#define DRV_USB_HOST_NAK_LIMIT              200

//
//  USB Host
//
#define USB_HOST_INSTANCES_NUMBER           1
#define USB_HOST_TPL_ENTRIES                1
#define USB_HOST_MAX_DRIVER_SUPPORTED       1    
#define USB_HOST_MAX_DEVICES_NUMBER         1
#define USB_HOST_MAX_CONFIGURATION          4
#define USB_HOST_MAX_INTERFACES             2
#define USB_HOST_CLIENTS_NUMBER             1
#define USB_HOST_INT_VECTOR                 INT_VECTOR_USB1         // See system_interrupt.c
#define USB_HOST_INT_PRIORITY               INT_PRIORITY_LEVEL4
#define USB_HOST_INT_SUB_PRIORITY           INT_SUBPRIORITY_LEVEL0

#define USB_HOST_BLUETOOTH_INSTANCES_NUMBER 1
#define USB_HOST_BLUETOOTH_TRY_COUNT        200     // Fail safe


#endif
